function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState } from "react";
import { ThemeProvider, createMuiTheme } from "@material-ui/core/styles";
import Box from "@material-ui/core/Box";
import TextField from "@material-ui/core/TextField";
import MenuItem from "@material-ui/core/MenuItem";
import FormControl from "@material-ui/core/FormControl";
import Select from "@material-ui/core/Select";
import Input from "@material-ui/core/Input";
import InputLabel from "@material-ui/core/InputLabel";
import InputAdornment from "@material-ui/core/InputAdornment";
import FormHelperText from "@material-ui/core/FormHelperText";
import MailOutlined from "@material-ui/icons/MailOutlined";
import { createTextfieldBootstrapStyles, useTextfieldBootstrapStyles } from "./TextfieldBootstrap.styles";

function withContainer(Story, context) {
  return /*#__PURE__*/React.createElement(Box, {
    width: 320
  }, /*#__PURE__*/React.createElement(Story, context));
}

var baseTheme = createMuiTheme({
  typography: {
    fontFamily: 'system-ui,-apple-system,"Segoe UI",Roboto,"Helvetica Neue",Arial,"Noto Sans","Liberation Sans",sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji"'
  }
});
var textfieldStandardStyles = createTextfieldBootstrapStyles(baseTheme);

function withTheme(Story, context) {
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: _extends({}, baseTheme, {
      components: textfieldStandardStyles
    })
  }, /*#__PURE__*/React.createElement(Story, context));
}

export default {
  title: "Component/Textfield/Boostrap",
  component: TextField,
  argTypes: {
    size: {
      control: {
        type: "select",
        options: ["medium", "small"]
      }
    },
    variant: {
      control: {
        type: "select",
        options: ["standard", "filled", "outlined"]
      }
    },
    margin: {
      control: {
        type: "select",
        options: ["none", "dense", "normal"]
      }
    }
  },
  args: {
    error: false,
    variant: "standard",
    label: "Label",
    disabled: false
  },
  parameters: {
    layout: "centered"
  },
  decorators: [withTheme, withContainer]
};
export var Field = function Field(args) {
  return /*#__PURE__*/React.createElement(TextField, args, "Children");
};
Field.args = {
  placeholder: "Placeholder",
  fullWidth: true,
  size: "medium",
  helperText: "This is a helper text"
};
export var FieldError = function FieldError(args) {
  return /*#__PURE__*/React.createElement(TextField, args, "Children");
};
FieldError.args = {
  error: true,
  placeholder: "Placeholder",
  fullWidth: true,
  size: "medium",
  helperText: "This is a helper text"
};
export var FieldIcon = function FieldIcon(args) {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    margin: "dense",
    InputProps: {
      startAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "start"
      }, /*#__PURE__*/React.createElement(MailOutlined, null))
    }
  }), "Children"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    margin: "dense",
    InputProps: {
      endAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "end"
      }, /*#__PURE__*/React.createElement(MailOutlined, null))
    }
  }), "Children"));
};
FieldIcon.args = {
  placeholder: "Placeholder",
  fullWidth: true,
  size: "medium",
  helperText: "This is a helper text"
};
export var SelectField = function SelectField(args) {
  var _useState = useState(""),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  return /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    select: true,
    SelectProps: {
      displayEmpty: true
    },
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    }
  }), /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, /*#__PURE__*/React.createElement("em", null, "Select Option")), /*#__PURE__*/React.createElement(MenuItem, {
    value: 1
  }, "Option 1"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 2
  }, "Option 2"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 3
  }, "Option 3"));
};
SelectField.args = {
  fullWidth: true,
  size: "medium",
  helperText: "This is a helper text"
};
export var SelectError = function SelectError(args) {
  var _useState3 = useState(""),
      _useState4 = _slicedToArray(_useState3, 2),
      value = _useState4[0],
      setValue = _useState4[1];

  return /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    select: true,
    SelectProps: {
      displayEmpty: true
    },
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    }
  }), /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, /*#__PURE__*/React.createElement("em", null, "Select Option")), /*#__PURE__*/React.createElement(MenuItem, {
    value: 1
  }, "Option 1"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 2
  }, "Option 2"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 3
  }, "Option 3"));
};
SelectError.args = {
  error: true,
  fullWidth: true,
  size: "medium",
  helperText: "This is a helper text"
};
export var SelectIcon = function SelectIcon(args) {
  var _useState5 = useState(""),
      _useState6 = _slicedToArray(_useState5, 2),
      value = _useState6[0],
      setValue = _useState6[1];

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    select: true,
    SelectProps: {
      displayEmpty: true
    },
    InputProps: {
      startAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "start"
      }, /*#__PURE__*/React.createElement(MailOutlined, null))
    },
    margin: "dense",
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    }
  }), /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, /*#__PURE__*/React.createElement("em", null, "Select Option")), /*#__PURE__*/React.createElement(MenuItem, {
    value: 1
  }, "Option 1"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 2
  }, "Option 2"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 3
  }, "Option 3")), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    select: true,
    SelectProps: {
      displayEmpty: true
    },
    InputProps: {
      endAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "end"
      }, /*#__PURE__*/React.createElement(MailOutlined, null))
    },
    margin: "dense",
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    }
  }), /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, /*#__PURE__*/React.createElement("em", null, "Select Option")), /*#__PURE__*/React.createElement(MenuItem, {
    value: 1
  }, "Option 1"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 2
  }, "Option 2"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 3
  }, "Option 3")));
};
SelectIcon.args = {
  fullWidth: true,
  size: "medium",
  helperText: "This is a helper text"
};
export var ManuallyCompose = function ManuallyCompose(args) {
  var _useState7 = useState(""),
      _useState8 = _slicedToArray(_useState7, 2),
      value = _useState8[0],
      setValue = _useState8[1];

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(FormControl, args, /*#__PURE__*/React.createElement(InputLabel, null, "Manual Label"), /*#__PURE__*/React.createElement(Input, {
    placeholder: "Placeholder"
  }), /*#__PURE__*/React.createElement(FormHelperText, null, "Hey! need help")), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(FormControl, args, /*#__PURE__*/React.createElement(InputLabel, null, "Manual Label"), /*#__PURE__*/React.createElement(Select, {
    displayEmpty: true,
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    }
  }, /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, /*#__PURE__*/React.createElement("em", null, "Select Option")), /*#__PURE__*/React.createElement(MenuItem, {
    value: 1
  }, "Option 1"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 2
  }, "Option 2"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 3
  }, "Option 3")), /*#__PURE__*/React.createElement(FormHelperText, null, "Hey! need help")));
};
ManuallyCompose.args = {
  error: false,
  size: "medium",
  margin: "normal"
};

function withBaseTheme(Story, context) {
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: baseTheme
  }, /*#__PURE__*/React.createElement(Story, context));
}

export var OutsideTheme = function OutsideTheme(args) {
  var _useState9 = useState(""),
      _useState10 = _slicedToArray(_useState9, 2),
      value = _useState10[0],
      setValue = _useState10[1];

  var styles = useTextfieldBootstrapStyles();
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    InputLabelProps: {
      classes: styles.InputLabel
    },
    InputProps: {
      classes: styles.Input,
      disableUnderline: true,
      startAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "start",
        classes: styles.InputAdornment
      }, /*#__PURE__*/React.createElement(MailOutlined, null))
    },
    FormHelperTextProps: {
      classes: styles.FormHelperText
    },
    placeholder: "placeholder",
    helperText: "Only standard variant works with this approach!"
  })), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(TextField, _extends({}, args, {
    select: true,
    SelectProps: {
      displayEmpty: true,
      classes: styles.Select
    },
    InputLabelProps: {
      classes: styles.InputLabel
    },
    InputProps: {
      classes: styles.Input,
      disableUnderline: true,
      endAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "end",
        classes: styles.InputAdornment
      }, /*#__PURE__*/React.createElement(MailOutlined, null))
    },
    helperText: "Only standard variant works with this approach!",
    FormHelperTextProps: {
      classes: styles.FormHelperText
    },
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    }
  }), /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, /*#__PURE__*/React.createElement("em", null, "Select Option")), /*#__PURE__*/React.createElement(MenuItem, {
    value: 1
  }, "Option 1"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 2
  }, "Option 2"), /*#__PURE__*/React.createElement(MenuItem, {
    value: 3
  }, "Option 3")));
};
OutsideTheme.args = {
  margin: "dense"
};
OutsideTheme.decorators = [withBaseTheme];